/*
 * Interprocess communication operations.
 *
 * Copyright (C) 2018, 2019 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/re/c/dataspace.h>
#include <l4/sys/ipc.h>
#include <l4/sys/types.h>



EXTERN_C_BEGIN

/* Direct operations. */

long ipc_expect_capabilities(int number);
long ipc_expect_capability(int item);
void ipc_export_capability(l4_msgtag_t tag, int item, l4_cap_idx_t ref);
long ipc_import_capability(l4_msgtag_t tag, int item, l4_cap_idx_t *ref);
long ipc_import_dataspace(l4_msgtag_t tag, int item, l4re_ds_t *mem, l4_addr_t *addr);

EXTERN_C_END
